package com.jxdinfo.hussar.core.bouncycastle.math.ec;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jxdinfo.hussar.core.bouncycastle.math.ec.ECCurve;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.ECFieldElement;
import com.jxdinfo.hussar.core.bouncycastle.math.ec.ECPoint;
import com.jxdinfo.hussar.core.util.ProductInfo;
import java.math.BigInteger;

public class Fp extends ECPoint {
  public byte[] getEncoded() {
    if (isInfinity()) {
      true;
      return true;
    } 
    while (true) {
      int i = ECPoint.try().getByteLength(this.G);
      if (this.withCompression) {
        if (getY().toBigInteger().testBit(0)) {
          byte[] arrayOfByte;
          byte b = 3;
          true;
          boolean bool = true;
          bool[0] = b;
          System.arraycopy(arrayOfByte, 0, bool, 1, arrayOfByte.length);
          return bool;
        } 
      } else {
        byte[] arrayOfByte1 = ECPoint.try().integerToBytes(getX().toBigInteger(), i);
        byte[] arrayOfByte2 = ECPoint.try().integerToBytes(getY().toBigInteger(), i);
        true;
        boolean bool = true;
        bool[0] = true;
        System.arraycopy(arrayOfByte1, 0, bool, 1, arrayOfByte1.length);
        System.arraycopy(arrayOfByte2, 0, bool, arrayOfByte1.length + 1, arrayOfByte2.length);
        return bool;
      } 
      while (true) {
        byte[] arrayOfByte;
        byte b = 2;
        true;
        boolean bool = true;
        bool[0] = b;
        System.arraycopy(arrayOfByte, 0, bool, 1, arrayOfByte.length);
        return bool;
      } 
    } 
  }
  
  public Fp(ECCurve eCCurve, ECFieldElement eCFieldElement1, ECFieldElement eCFieldElement2) {
    this(eCCurve, eCFieldElement1, eCFieldElement2, false);
  }
  
  public Fp(ECCurve eCCurve, ECFieldElement eCFieldElement1, ECFieldElement eCFieldElement2, int i) {
    super(eCCurve, eCFieldElement1, eCFieldElement2);
    if ((eCFieldElement1 != null && eCFieldElement2 == null) || (eCFieldElement1 == null && eCFieldElement2 != null))
      throw new IllegalArgumentException(ProductInfo.if("6\000TP\nY\001XZ};57`kM\034ZR^\034G\003\026\037u1C\006\017IK\001\030\034LRL\032\004I")); 
    this.withCompression = i;
  }
  
  public ECPoint add(ECPoint eCPoint) {
    if (isInfinity())
      return eCPoint; 
    while (true) {
      if (eCPoint.isInfinity())
        return this; 
      while (true) {
        if (this.G.equals(eCPoint.G))
          return this.e.equals(eCPoint.e) ? twice() : this.C.getInfinity(); 
        ECFieldElement eCFieldElement5 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).square().subtract(this.G).subtract(eCPoint.G);
        ECFieldElement eCFieldElement6 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).multiply(this.G.subtract(eCFieldElement5)).subtract(this.e);
        return new Fp(this.C, eCFieldElement5, eCFieldElement6);
      } 
      ECFieldElement eCFieldElement3 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).square().subtract(this.G).subtract(eCPoint.G);
      ECFieldElement eCFieldElement4 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).multiply(this.G.subtract(eCFieldElement3)).subtract(this.e);
      return new Fp(this.C, eCFieldElement3, eCFieldElement4);
    } 
    while (true) {
      if (this.G.equals(eCPoint.G))
        return this.e.equals(eCPoint.e) ? twice() : this.C.getInfinity(); 
      ECFieldElement eCFieldElement3 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).square().subtract(this.G).subtract(eCPoint.G);
      ECFieldElement eCFieldElement4 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).multiply(this.G.subtract(eCFieldElement3)).subtract(this.e);
      return new Fp(this.C, eCFieldElement3, eCFieldElement4);
    } 
    ECFieldElement eCFieldElement1 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).square().subtract(this.G).subtract(eCPoint.G);
    ECFieldElement eCFieldElement2 = eCPoint.e.subtract(this.e).divide(eCPoint.G.subtract(this.G)).multiply(this.G.subtract(eCFieldElement1)).subtract(this.e);
    return new Fp(this.C, eCFieldElement1, eCFieldElement2);
  }
  
  synchronized void enum() {
    if (this.multiplier == null) {
      this;
      super();
    } 
  }
  
  public ECPoint subtract(ECPoint eCPoint) {
    if (eCPoint.isInfinity())
      return this; 
    while (true)
      return add(eCPoint.negate()); 
  }
  
  public ECPoint negate() {
    return new Fp(this.C, this.G, this.e.negate(), this.withCompression);
  }
  
  public ECPoint twice() {
    if (isInfinity())
      return this; 
    while (true) {
      if (this.e.toBigInteger().signum() == 0)
        return this.C.getInfinity(); 
      while (true) {
        ECFieldElement eCFieldElement1 = this.C.fromBigInteger(BigInteger.valueOf(2L));
        ECFieldElement eCFieldElement2 = this.C.fromBigInteger(BigInteger.valueOf(3L));
        eCFieldElement2 = this.G.square().multiply(eCFieldElement2).add(this.C.e).divide(this.e.multiply(eCFieldElement1)).square().subtract(this.G.multiply(eCFieldElement1));
        ECFieldElement eCFieldElement3 = this.G.square().multiply(eCFieldElement2).add(this.C.e).divide(this.e.multiply(eCFieldElement1)).multiply(this.G.subtract(eCFieldElement2)).subtract(this.e);
        return new Fp(this.C, eCFieldElement2, eCFieldElement3, this.withCompression);
      } 
    } 
    while (true) {
      ECFieldElement eCFieldElement1 = this.C.fromBigInteger(BigInteger.valueOf(2L));
      ECFieldElement eCFieldElement2 = this.C.fromBigInteger(BigInteger.valueOf(3L));
      eCFieldElement2 = this.G.square().multiply(eCFieldElement2).add(this.C.e).divide(this.e.multiply(eCFieldElement1)).square().subtract(this.G.multiply(eCFieldElement1));
      ECFieldElement eCFieldElement3 = this.G.square().multiply(eCFieldElement2).add(this.C.e).divide(this.e.multiply(eCFieldElement1)).multiply(this.G.subtract(eCFieldElement2)).subtract(this.e);
      return new Fp(this.C, eCFieldElement2, eCFieldElement3, this.withCompression);
    } 
  }
}
